/*
File: BeanHandle.java
Date		Author		Changes		
Mar 08 98	Lukasz Beca	Created
*/

package webwisdom.tango.structures;

import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.Handle;
import netscape.javascript.JSObject;
import webwisdom.tango.beans.TangoBean;
import webwisdom.tango.consts.Const;

public class BeanHandle implements Handle, Runnable {


  private TangoBean bean;  
  private int AID;
  private JSObject window;
  private LocalApplications lapps;


  private MessageQueue q;
  private boolean exit; 
  private Thread th;

 
  public BeanHandle(TangoBean tb, JSObject win, int AIDpar, LocalApplications la) {

    window = win;
    AID = AIDpar;
    lapps = la;
    bean = tb;
    q = new MessageQueue();
    th = new Thread(this);
    exit = false;
    th.start();

       
  }
  
  public void run() {

    Message m;
    AppEventMessage am;
    int type;
    byte data[];
    int ctype;

   

    System.out.println("ScriptHandle: script thread number " + AID+ "  started");
   
    
    while(!exit) {

      //System.out.println("ThreadOut: Thread number " + thisno + " sending");
        m = q.getMessage();     

        if (!exit) {
         
          type = m.getType();

          if (type == Const.CONTROL) {
            
	    am = (AppEventMessage) m;
            data = am.getData();
       //     System.out.println("BeanHandle: received control" + args);
            bean.receiveControlFromTango(data); 	    	    
	    
          } else {
	  
            am = (AppEventMessage) m;
            data = am.getData();
       //     System.out.println("BeanHandle: received " + args);
            bean.receiveFromTango(data); 
          }              
        }         
    }
  }
  
   public void finish() {


     window.eval("close();");

   }

   public void setFocus() {

     window.eval("focus();");
   }
  

  public void putMessage(byte data[]) {

    System.out.println("BeanHandle: message received");
    lapps.sendAppToOther(AID,new AppEventMessage(Const.DATA,data));

  }  
  
  public void putControlMessage(byte data[]) {

    System.out.println("BeanHandle: message received");
    lapps.sendAppToOther(AID,new AppEventMessage(Const.CONTROL,data));

  }  

  
    
  public void remove() {
     System.out.println("BeanHandle: removing script " + AID);
     exit = true;
     q.unblock();
     lapps.terminated(AID);
  }
   
   
   public void sendLAToApp(Message m) {
    
       q.putMessage(m);

  }
}


